<?php

class Brivium_CreditsIntegration_UserUpgrades_ControllerAdmin_UserUpgrade extends XFCP_Brivium_CreditsIntegration_UserUpgrades_ControllerAdmin_UserUpgrade
{
	/**
	 * Gets the upgrade add/edit form response.
	 *
	 * @param array $upgrade
	 *
	 * @return XenForo_ControllerResponse_View
	 */
	protected function _getUpgradeAddEditResponse(array $upgrade)
	{
		$response = parent::_getUpgradeAddEditResponse($upgrade);
		if(!empty($response->params)){
			$currencies = $this->getCreditHelper('Credit')->assertCurrenciesValidAndViewable('BRCIPurchaseUserUpgrade');
			if($currencies){
				$response->params['brcCurrencies'] = $currencies;
			}
			
		}
		return $response;
	}

	public function actionSave()
	{
		$GLOBALS['BRCIUU_ControllerAdmin_UserUpgrade_actionSave'] = $this;
		return parent::actionSave();
	}
	public function BRCIUUActionSave(XenForo_DataWriter_UserUpgrade $dw)
	{
		$usingCredit = $this->_input->filterSingle('brciuu_using_credit', XenForo_Input::UINT);
		$currencyId = $this->_input->filterSingle('brciuu_currency_id', XenForo_Input::UINT);
		//pr(array());
		//prd($currencyId);
		$dw->set('brciuu_using_credit', $usingCredit);
		$dw->set('brciuu_currency_id', $currencyId);
		$dw->set('cost_currency', 'usd');
	}
	
	public function getCreditHelper($class)
	{
		if (strpos($class, '_') === false)
		{
			$class = 'Brivium_Credits_ControllerHelper_' . $class;
		}

		$class = XenForo_Application::resolveDynamicClass($class);

		return new $class($this);
	}
	
	public function actionDowngrade()
	{
		$GLOBALS['BRCIUU_ControllerAdmin_UserUpgrade_actionDowngrade'] = true;
		return parent::actionDowngrade();
	}
	
	/**
	 * Gets the action model.
	 *
	 * @return Brivium_Credits_Model_Credit
	 */
	protected function _getCreditModel()
	{
		return $this->getModelFromCache('Brivium_Credits_Model_Credit');
	}
}