<?php
class Brivium_CreditsIntegration_UserUpgrades_Installer extends Brivium_BriviumLibrary_Installer
{	
	public static function getTables()
	{
		$tables = array();
		return $tables;
	}
	
	public static function getAlters()
	{
		$alters = array();
		$alters['xf_user_upgrade'] = array(
			'brciuu_using_credit'	=>	"",
			'brciuu_currency_id'	=>	"",
		);
		$alters['xf_user_upgrade_active'] = array(
			'brciuu_record_credit'	=>	"",
			'brciuu_record_subscribe'	=>	"",
		);
		return $alters;
	}
	public static function getData()
	{
		$data = array();
		return $data;
	}
	
	public static function init()
	{
		self::$_tables = self::getTables();
		self::$_alters = self::getAlters();
		self::$_data = self::getData();
	}
	protected static function _installVersionCurrent()
	{
		$db = self::_getDb();
		if (!self::checkIfExist('xf_user_upgrade', 'brciuu_using_credit')) {
			$db->query(" ALTER TABLE  `xf_user_upgrade` ADD  `brciuu_using_credit` tinyint(3) unsigned NOT NULL DEFAULT '0' ");
		}
		if (!self::checkIfExist('xf_user_upgrade', 'brciuu_currency_id')) {
			$db->query("ALTER TABLE `xf_user_upgrade` ADD `brciuu_currency_id` int(10) unsigned NOT NULL DEFAULT '0' ");
		}
		if (!self::checkIfExist('xf_user_upgrade_active', 'brciuu_record_credit')) {
			$db->query("ALTER TABLE `xf_user_upgrade_active` ADD `brciuu_record_credit` tinyint(3) unsigned NOT NULL DEFAULT '0' ");
		}
		if (!self::checkIfExist('xf_user_upgrade_active', 'credit_price')) {
			$db->query("ALTER TABLE `xf_user_upgrade_active` ADD `brciuu_record_subscribe` tinyint(3) unsigned NOT NULL DEFAULT '0' ");
		}
		
	}
	public static function install($existingAddOn, $addOnData)
	{
		$creditsAddon = XenForo_Model::create('XenForo_Model_AddOn')->getAddOnVersion('Brivium_Credits');
		if (!$creditsAddon) {
            throw new XenForo_Exception('Brivium Credits Addon required', true);
        }
		
		self::_install($existingAddOn);
		self::_installVersionCurrent();
	}
	public static function uninstall()
	{
		$creditsAddon = XenForo_Model::create('XenForo_Model_AddOn')->getAddOnVersion('Brivium_Credits');
		if ($creditsAddon) {
			$dw = XenForo_DataWriter::create('Brivium_Credits_DataWriter_Action', XenForo_DataWriter::ERROR_SILENT);
			if ($dw->setExistingData('BRCIPurchaseUserUpgrade'))
			{
				$dw->delete();
			}
		}
		self::init();
		self::_uninstall();
	}
}

?>
